(define-param N 50)
(define-param f 0.99)
(define-param dpml 1)
(define-param nx 5)
(define sy 10)
(define ysrc (- (/ sy 2) dpml))
(define-param fcen 1.041666667)
(define-param df 1.25)
(define-param deterministic? #f)
(define randomheight 1)
(define-param nsilicon 3.679)
(define-param ksilicon 0.00406)

(define sigmasilicon (/ (* 4 pi fcen nsilicon ksilicon) (- (* nsilicon nsilicon) (* ksilicon ksilicon))))
(set-param! resolution 40)

; z(n+1) = f*z(n) + sqrt(1-f^2)*(random:normal)
;(define sequence (list '0))
;(define-param curr 0)
;(define (randomcorr current idx)
;    (if (< idx N)
;		(randomcorr (+ (* f current) (* (sqrt (- 1 (* f f))) (random:normal))) (+ idx 1))
;		0)
;  (print current"\n"))
;  (append! sequence (list current)))
;(randomcorr curr n)
;(print sequence)

(if (not deterministic?)
    (let ((time (gettimeofday)))
      (set! *random-state*
            (seed->random-state (+ (car time)
                                   (cdr time))))))
(define-param rand-init? true)
(define silicon_m (make medium (index nsilicon) (D-conductivity sigmasilicon)))
(set! geometry-lattice (make lattice (size nx sy no-size)))


(define (makerandomblocks curr idx)
  (append (list (make block 
                  (center (- (* (- idx 1) (/ nx N)) (/ nx 2) (/ nx (* 2 N))) 0)
                  (material silicon_m)
		  (size (/ nx N) (* randomheight (+ curr 2)))))
		  (if (< idx N)
			  (makerandomblocks (+ (* f curr) (* (sqrt (- 1 (* f f))) (random:normal))) (+ idx 1))
			  (list (make block 
                  		  (center (- (* N (/ nx N)) (/ nx 2) (/ nx (* 2 N))) 0)
                  		  (material silicon_m)
		  		  (size (/ nx N) (* randomheight (+ 0 2)))))) ))

(set! geometry (makerandomblocks 0 2))
(define k-point (vector3 0 0 0))
; (set! ensure-periodicity true)
(set! pml-layers (list (make pml (direction Y) (thickness dpml))))

(set! sources (list (make source
                        (src (make gaussian-src (frequency fcen) (fwidth df)))
                        (component Ez) (size nx 0) (center 0 ysrc))))

(run-sources (at-beginning output-epsilon))


